@REM BEGIN COPYRIGHT
@REM *************************************************************************
@REM 
@REM  Licensed Materials - Property of IBM
@REM  5725-C94, 5725-C95, 5725-C96
@REM  (C) Copyright IBM Corporation 2013. All Rights Reserved.
@REM  US Government Users Restricted Rights- Use, duplication or disclosure
@REM  restricted by GSA ADP Schedule Contract with IBM Corp.
@REM 
@REM *************************************************************************
@REM END COPYRIGHT

@ECHO OFF
SETLOCAL

ECHO.
ECHO IBM Business Process Manager 8.5.0 Upgrade
ECHO.

SET CUR_DIR=%cd%
cd /d "%~dp0.."
SET WAS_HOME=%cd%
cd /d %WAS_HOME%\bin

SET JAVA_HOME=%WAS_HOME%\java

:setupArguments
SET DBUPGRADE_RESOURCE_DIR=%WAS_HOME%\util\dbUpgrade\
SET RC=0
SET WAS_HOME_PROP=-Dwas.install.root="%WAS_HOME%"
SET APP_JAVA_POLICY=-Djava.security.policy="file:%DBUPGRADE_RESOURCE_DIR%java.policy"
SET NODE_NAME_PROP=
SET SERVER_NAME_PROP=
SET LOGGING_PROP=-Dcom.lombardisoftware.ant.JULDefaultLogger.level=DEBUG -Djava.util.logging.config.file="%DBUPGRADE_RESOURCE_DIR%logging.properties" -Dtw.log4j.init=false
SET LOGGING_FILTER_PROP=-Dcom.ibm.bpm.migration.logging.StringFilter.excludes=contains(db.password);equals(WSVR0072W);equals(WSVR0801I);equals(WKSP0500);equals(WSVR0643I);regexp(^Class.+loaded.from.ant.loader..parentFirst.);regexp(^Class.+loaded.from.parent.loader..parentFirst.);regexp(^Finding.class.+\..+\..+);regexp(^Loaded.from.+\.jar..+\.class$)
SET LOGGING_PROP=%LOGGING_PROP% %LOGGING_FILTER_PROP%
SET ANT_PROPS=-q -e -logger com.lombardisoftware.ant.JULDefaultLogger
SET UPGRADECOMMAND_PROP=-Dupgradecommand="%0 %*"
set COMMAND_NAME_PROPS=-Dmig.command.name=%~n0

:processArguments
IF "%1" == "-?" GOTO help
IF "%1" == "-help" GOTO help

IF "%1"=="-propertiesFile" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET MIGRATION_PROPERTIES_FILE=-DpropertiesFile=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-backupFolder" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET BACKUP_FOLDER_PROP=-DbackupFolder=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-noPrompt" (
	SET NO_PROMPT_PROP=-DnoPrompt=true&SHIFT&GOTO processArguments
)

IF NOT "%1"=="" (
	ECHO Invalid parameter: %1%, please correct it and try again.
	GOTO help
)

SET CLASSPATH=%DBUPGRADE_RESOURCE_DIR%
SET CLASSPATH=%CLASSPATH%;%DBUPGRADE_RESOURCE_DIR%lib\ant.jar
SET CLASSPATH=%CLASSPATH%;%DBUPGRADE_RESOURCE_DIR%lib\ant-launcher.jar
SET CLASSPATH=%CLASSPATH%;%DBUPGRADE_RESOURCE_DIR%lib\ant-nodeps.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\ant-contrib.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\twant.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\plugins\com.ibm.bpm.migration.logging.jar

SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ffdc.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.hpel.logging.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.admin.core.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.admin.services.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.bootstrap.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.emf.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.javaee.dd.common.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.javaee.dd.ejb.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.runtime.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.wccm.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.wlm.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.wsfp.main.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.wsspi.extension.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.core.runtime_.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.equinox.common_.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.equinox.registry.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.osgi_.jar

SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/lib/bootstrap.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/lib/j2ee.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/BPM/Lombardi/lib/org.eclipse.emf.ecore.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/BPM/Lombardi/lib/org.eclipse.emf.common.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/BPM/Lombardi/lib/org.eclipse.emf.ecore.xmi.jar

"%JAVA_HOME%\bin\java" -cp "%CLASSPATH%" %WAS_HOME_PROP% %APP_JAVA_POLICY% %COMMAND_NAME_PROPS% %MIGRATION_PROPERTIES_FILE% %BACKUP_FOLDER_PROP% %NO_PROMPT_PROP% %LOGGING_PROP% %UPGRADECOMMAND_PROP% org.apache.tools.ant.Main -buildfile "%DBUPGRADE_RESOURCE_DIR%upgrade.xml" %ANT_PROPS%
SET RC=%ERRORLEVEL%
GOTO end

:NoValueSpecified
ECHO No value specified for parameter %1
GOTO help

:help
ECHO.
ECHO Starts or continues the upgrade.
ECHO .
ECHO Usage:
ECHO.
ECHO    DBUpgrade.bat [options...]
ECHO.
ECHO Options:
ECHO    -?, -help                               This help message
ECHO    -propertiesFile  ^<full path^>          Full path of migration properties file
ECHO    -backupFolder ^<directory^>             Directory of backup folder from source environment
ECHO    -noPrompt                               Set -noPrompt flag to make the tool work with no interaction. If you do not set this parameter, the tool will prompt you to confirm (optional)
ECHO .
GOTO end

:end
ECHO.
EXIT /B %RC%
ENDLOCAL
