@REM 5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70 (C) COPYRIGHT International Business Machines Corp. 2012
@REM All Rights Reserved * Licensed Materials - Property of IBM
@REM US Government Users Restricted Rights - Use, duplication or di`sclosure
@REM restricted by GSA ADP Schedule Contract with IBM Corp.
                               
@echo off

setlocal
SETLOCAL ENABLEEXTENSIONS

REM Detect how script was launched.  The INV_PAUSE_ON_CLOSE
REM variable is used to prevent a cmd window from closing when
REM launched from an explorer window
@echo %cmdcmdline% | findstr /R /C:"cmd.* /[cC] " > NUL
if %ERRORLEVEL% EQU 0 set INV_PAUSE_ON_CLOSE=1


if exist "%~dp0setupCmdLine.bat" CALL "%~dp0setupCmdLine.bat" %* 

set "MY_ISADC_HOME=%WAS_HOME%/BPM/isadc"

if exist "%JAVA_HOME%\bin\java.exe" (
   set JAVA_EXE="%JAVA_HOME%\bin\java"
) else (
   set JAVA_EXE="%JAVA_HOME%\jre\bin\java"
)

set CMD_NAME=%~nx0
set CMD_NAME_ONLY=%~n0
set PRODUCT_INVOKE=TRUE
set "CURRENT_DIR=%~dp0%"

FOR %%I IN ("%CURRENT_DIR%") DO SET CURRENT_DIR=%%~sI

:: end 


SET COLLECTORTYPE=
SET "UPLOAD=FALSE"
SET PMRNUMBER=
SET "CONFIG=FALSE"
SET OUTPUTDIR=

:CHECKSWITCH

if /I "%1" == "-help"  goto displayHelp
if /I "%1" == "-Help"  goto displayHelp
if /I "%1" == "/h" goto displayHelp
if /I "%1" == "-h" goto displayHelp
if /I "%1." == "-collectorType." goto setCollectorType
if /I "%1." == "-type." goto setCollectorType
if /I "%1." == "-pmrNumber." goto setPMRNumber
if /I "%1." == "-PMR." goto setPMRNumber
if /I "%1." == "-pmr." goto setPMRNumber
if /I "%1." == "-config." goto setConfig
if /I "%1." == "-uploadToIBM." goto setUpload
if /I "%1." == "-outputDirectory." goto setOutputDirectory

goto processParameters 

:setCollectorType
 
SET COLLECTORTYPE=%~2
set isCollectorTypeSet=TRUE
REM echo COLLECTORTYPE is %COLLECTORTYPE%

if /I "%COLLECTORTYPE%" == "General" goto jumpOut 
if /I "%COLLECTORTYPE%" == "Install" goto jumpOut 
if "%COLLECTORTYPE%" NEQ "General" (
goto displayHelp
)

:jumpOut
:: end jumpOut
SHIFT 
SHIFT
rem goto parsePMR
goto :CHECKSWITCH
:: end setCollectorType


:setPMRNumber

SET PMRNUMBER=%~2
rem FOR /F "delims=,. tokens=1-3" %%f IN ("%PMRNUMBER%") DO (
rem 	set PMRNUMBER=%%f.%%g.%%h
rem )
REM echo PMRNUMBER is %PMRNUMBER%
SET isPmrNumberSet=TRUE
SHIFT 
SHIFT
goto parsePMR
goto :CHECKSWITCH
:: end setPMRnumber

:setConfig 
 
set CONFIG=%~2
REM echo CONFIG is %CONFIG%
set isConfigSet=TRUE
SHIFT 
SHIFT
goto :CHECKSWITCH

:: end setConfig

:setUpload
 
set UPLOAD=%~2
REM echo UPLOAD IS %UPLOAD% 
set isUploadSet=TRUE
SHIFT 
SHIFT
goto :CHECKSWITCH

:: end setConfig

: setOutputDirectory

set OUTPUTDIR=%~2
set isOutputDirectorySet=TRUE
SHIFT
SHIFT
goto :CHECKSWITCH

:: end setOutputDirectory


:displayHelp

echo. 
echo Command invocation example
echo.
echo bpmdc.bat -type=General -PMR=(pmrNumber) -config=yes -uploadToIBM=yes -outputDirectory=(location of output directory)
echo 	where type=General / Install 	{Optional}  {Defaults to General} 
echo 	PMR in 11111.bbb.CCC format	{Optional}  {Defaults to none, No upload}
echo 	config option to collect the config directory {Optional}  {Defaults to No}
echo 	uploadToIBM to send the collected data with FTP option {Optional} {Defaults to No}
echo 	outputDirectory is the location where you want to create the output zip { Defaults to WAS_HOME/BPM/isadc folder }
echo 	-help to display help
echo. 		
echo If invoked without any option then the default options will be picked.
echo The Default options are 
echo -type=General -config=no -uploadToIBM=No {PMR not needed} -outputDirectory=(Full path to collection)

goto end 

rem exit
:: end displayHelp

:parsePMR

rem echo PMRNUMBER is %PMRNUMBER%
FOR /F "tokens=1,2,3 delims=.," %%A in ("%PMRNUMBER%") Do (
SET pmrNo=%%A 
SET BranchNum=%%B 
SET CountryCode=%%C
)
set firstLen=0
set secondLen=0
set thirdLen=0

:pmrLoop
if defined pmrNo (set pmrNo=%pmrNo:~1%&set /A firstLen += 1&goto pmrLoop)

:BranchLoop
if defined BranchNum (set BranchNum=%BranchNum:~1%&set /A secondLen += 1&goto BranchLoop)

:CountryCodeLoop
if defined CountryCode (set CountryCode=%CountryCode:~1%&set /A thirdLen += 1&goto CountryCodeLoop)

set "validPMR=true"
if "%firstLen%" NEQ "6" set "validPMR=false"
if "%secondLen%" NEQ "4" set "validPMR=false"
if "%thirdLen%" NEQ "3" set "validPMR=false"

if "%validPMR%" == "false" ( 
echo.
echo Wrong PMR number format - %PMRNUMBER%
echo PMR Format should be PPPPP.BBB.CCC
echo where PPPPP is PMR Number, BBB is the branch and CCC is the country code.
goto displayHelp
exit /b 0
)
goto :CHECKSWITCH

:: end parsePMR

: processParameters
 
if NOT DEFINED isCollectorTypeSet set "COLLECTORTYPE=General"
 
if NOT DEFINED isConfigSet set "CONFIG=FALSE"

if NOT DEFINED isUploadSet set UPLOAD=FALSE
if NOT DEFINED isPmrNumberSet set UPLOAD=FALSE

if DEFINED isPmrNumberSet ( 
REM Check the PMR number format
set "toBeSentToEcurep=false"
 
if /I "%UPLOAD%" == "yes" set "toBeSentToEcurep=true"
if /I "%UPLOAD%" == "y" set "toBeSentToEcurep=true"
if "%UPLOAD%" == "Yes" set "toBeSentToEcurep=true"
) 

REM NOTE
REM We are doing everything in reference to USER_ISNTALL_ROOT-
REM Make sure we change this if we are to move ISA DC core to somewhere else
REM NOTE


FOR %%I IN ("%USER_INSTALL_ROOT%") DO SET USER_INSTALL_ROOT=%%~sI

set DATE_TIME=%DATE:/=-%_%TIME::=-%
set DATE_TIME=%DATE_TIME: =%

if DEFINED isOutputDirectorySet (
	FOR %%I IN ("%OUTPUTDIR%") DO SET OUTPUTDIR=%%~sI
	IF NOT EXIST "%OUTPUTDIR%" (
		md "%OUTPUTDIR%"  2>&1 >NUL
	)
	set "FILENAME=%OUTPUTDIR%/%COLLECTORTYPE%_%DATE_TIME%.zip"
	if DEFINED isPmrNumberSet set "FILENAME=%OUTPUTDIR%/%PMRNUMBER%_%COLLECTORTYPE%_%DATE_TIME%.zip"
 
	if "%toBeSentToEcurep%" == "true"  ( 
		set "FILENAME=%OUTPUTDIR%/%COLLECTORTYPE%_%DATE_TIME%.zip"
		set "FILENAMETOECUREP=%OUTPUTDIR%/%PMRNUMBER%.%COLLECTORTYPE%_%DATE_TIME%.zip"
	)
) else (
	set "FILENAME=%MY_ISADC_HOME%/%COLLECTORTYPE%_%DATE_TIME%.zip"
	if DEFINED isPmrNumberSet set "FILENAME=%MY_ISADC_HOME%/%PMRNUMBER%_%COLLECTORTYPE%_%DATE_TIME%.zip"
 
	if "%toBeSentToEcurep%" == "true" (
		set "FILENAME=%MY_ISADC_HOME%/%COLLECTORTYPE%_%DATE_TIME%.zip"
		set "FILENAMETOECUREP=%MY_ISADC_HOME%/%PMRNUMBER%.%COLLECTORTYPE%_%DATE_TIME%.zip"
	)
)
: writeToResponseFile
 
SET "RESP_FILE=%MY_ISADC_HOME%/util/ResponseFile.txt"
SET "PROP_FILE=%MY_ISADC_HOME%/util/properties.txt"


REM look into possibility of creating Datetime filename 
REM echo FILENAME is %FILENAME%

echo ### Begin Response File > "%RESP_FILE%"
echo ### Begin Properties File > "%PROP_FILE%"

echo 10.CollectionZipName=%FILENAME% >> "%RESP_FILE%"
echo 20.YesNo=1 >> "%RESP_FILE%"
if /I "%COLLECTORTYPE%" == "General" ( 
echo 30.CollectionOption=1 >> "%RESP_FILE%"
) 
if /I "%COLLECTORTYPE%" == "Install" (
echo 30.CollectionOption=2 >> "%RESP_FILE%"
) 
 


REM Properties file - populate 
REM echo config is %CONFIG%

if /I "%CONFIG%" == "yes" goto EditPropertiesFileForConfig 
if /I "%CONFIG%" == "y" goto EditPropertiesFileForConfig 
if "%CONFIG%" NEQ "yes" (
echo config=%CONFIG%>> "%PROP_FILE%"
goto jumpTo
)


:EditPropertiesFileForConfig
echo config=true>> "%PROP_FILE%"
:: end EditPropertiesFileForConfig

:jumpTo



if /I "%UPLOAD%" == "yes" goto EditResponseFileForUpload
if /I "%UPLOAD%" == "y" goto EditResponseFileForUpload
if "%UPLOAD%" NEQ "Yes" (
echo 40.SelectListOption=4 >> "%RESP_FILE%"
echo 50.OptionToCompleteInputDialog=1 >> "%RESP_FILE%"
)

goto InvokeCommand

:EditResponseFileForUpload
echo upload=%UPLOAD%>> "%PROP_FILE%"
echo pmr.number=%PMRNUMBER%>> "%PROP_FILE%"

echo 40.SelectListOption=2 >> "%RESP_FILE%"
echo 50.OptionToCompleteInputDialog=1 >> "%RESP_FILE%"
echo 60.MultipleChoiceInputRequest=1 >> "%RESP_FILE%"

:: end EditResponseFileForUpload


:InvokeCommand

FOR %%I IN ("%USER_INSTALL_ROOT%") DO SET USER_INSTALL_ROOT=%%~sI

echo Running the Collector command with the following options
ECHO /-------------------------------------------------------------------------------
echo type=%COLLECTORTYPE% 
echo config=%CONFIG% 
echo uploadToIBM=%UPLOAD% 
echo PMR=%PMRNUMBER% 
echo outputDirectory=%OUTPUTDIR%
echo \-------------------------------------------------------------------------------
echo. 
echo The collection is beginning and could take a few minutes depending on the size.

CALL "%MY_ISADC_HOME%/isadc.bat" -silent "%MY_ISADC_HOME%/util/ResponseFile.txt" > "%MY_ISADC_HOME%/util/ResponseLog.txt" 

IF EXIST "%FILENAME%" (

	ECHO /-------------------------------------------------------------------------------
    ECHO ^| Your collection file is located at :
	ECHO ^| %FILENAME%
	ECHO \-------------------------------------------------------------------------------
	ECHO.
  	ECHO Collection is complete
  	exit /b 0
) ELSE (
	if "%toBeSentToEcurep%" == "true" (
		IF EXIST "%FILENAMETOECUREP%" (
		
			ECHO /-------------------------------------------------------------------------------
		    ECHO ^| Your collection file is located at :
			ECHO ^| %FILENAMETOECUREP%
			ECHO \-------------------------------------------------------------------------------
			ECHO.
		  	ECHO Collection is complete
		  	exit /b 0
	) else ( 
		ECHO Collection failed.  Please see logs.
		exit /b 1
	)
)
	
 
)


: end
if defined INV_PAUSE_ON_CLOSE pause 
:: end END
endlocal